/*elk the LPC21x programmer: main function --- to be written
This program is a part of the stribog host software section

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Copyright (C) 2006 D.Ineiev <ineiev@yahoo.co.uk>*/
#include<stdlib.h>
#include<stdio.h>
#include"serialia.h"
#include<sys/ioctl.h>
#include<unistd.h>
#include<time.h>
#include<ncurses.h>
void initncurses(void)
{WINDOW*w;w=initscr();cbreak();noecho();nodelay(w,!0);refresh();}
void closencurses(void){endwin();}
int init(const char*s)
{int err=0;char c;initncurses();printf("setting up port \"%s\"...",s);refresh();
 if(initserialia(s)){err=-1;printf(" failed\n\r");closencurses();}
 else printf(" ok\n\r");refresh();return err;
}
static void delay(int centiseconds)
{clock_t t=clock();while(clock()-t<CLOCKS_PER_SEC/100*centiseconds);}
static int syncronize(const char*freq)
{const char query[]="?\n\r";char s[289];int n,i=0,f=11059;
 if(freq)sscanf(freq,"%i",&f);
 printf("Syncronizing baud rate...\n\r");refresh();
 do
 {scribe(query,3);printf("? sent %i\r",i++);refresh();delay(50);
  n=lege(s,sizeof(s));
 }while(n<=0);printf("received %i bytes: %s\n\r",n,s);refresh();return 0;
}
void closeall(void){closeserialia();closencurses();}
int main(int argc,char**argv)
{int err;if((err=init(argc<2?0:argv[1])))return err;
 if(syncronize(argc<3?0:argv[2]))goto ca;
 ca:closeall();return err;
}
